superstrict
ModuleInfo "Version: 1.21"
ModuleInfo "Author: Bruce A Henderson"
ModuleInfo "License: BSD"
ModuleInfo "Copyright: Wrapper - 2007-2023 Bruce A Henderson"
ModuleInfo "Copyright: SQLite - The original author of SQLite has dedicated the code to the public domain. Anyone is free to copy, modify, publish, use, compile, sell, or distribute the original SQLite code, either in source code form or as a compiled binary, for any purpose, commercial or non-commercial, and by any means."
ModuleInfo "Modserver: BRL"
ModuleInfo "History: 1.21"
ModuleInfo "History: Update to SQLite 3.44.2."
ModuleInfo "History: 1.20"
ModuleInfo "History: Update to SQLite 3.38.5."
ModuleInfo "History: 1.19"
ModuleInfo "History: Update to SQLite 3.37.2."
ModuleInfo "History: 1.18"
ModuleInfo "History: Update to SQLite 3.29.0."
ModuleInfo "History: Disable double-quoted string literals by default."
ModuleInfo "History: 1.17"
ModuleInfo "History: Update to SQLite 3.28.0."
ModuleInfo "History: 1.16"
ModuleInfo "History: Update to SQLite 3.27.2."
ModuleInfo "History: Fixed query free issue."
ModuleInfo "History: 1.15"
ModuleInfo "History: Update to SQLite 3.22.0."
ModuleInfo "History: Fixed for 64-bit targets."
ModuleInfo "History: 1.14"
ModuleInfo "History: Update to SQLite 3.8.11.1."
ModuleInfo "History: Added user authentication support."
ModuleInfo "History: 1.13"
ModuleInfo "History: Update to SQLite 3.8.2."
ModuleInfo "History: 1.12"
ModuleInfo "History: Update to SQLite 3.7.15."
ModuleInfo "History: Updated documentation."
ModuleInfo "History: Added loadOrSaveDB() function."
ModuleInfo "History: 1.11"
ModuleInfo "History: Update to SQLite 3.6.15."
ModuleInfo "History: Fixed prepared statement reuse issue."
ModuleInfo "History: Fixed problem where open/live queries could cause problem when committing."
ModuleInfo "History: Added getTableInfo() support."
ModuleInfo "History: Added blob support."
ModuleInfo "History: 1.10"
ModuleInfo "History: Update to SQLite 3.5.6."
ModuleInfo "History: Fixed lack of error reporting during query execution."
ModuleInfo "History: Transaction queries are finalized more quickly."
ModuleInfo "History: Statement should generally be reset before acquiring error message."
ModuleInfo "History: 1.09"
ModuleInfo "History: Update to SQLite 3.5.2. Now using the Amalgamated version."
ModuleInfo "History: Implementation of Date, DateTime and Time types."
ModuleInfo "History: 1.08"
ModuleInfo "History: Fixed null column types not being handled."
ModuleInfo "History: 1.07"
ModuleInfo "History: Fixed problem with lastInsertedId() not returning.. the last inserted id."
ModuleInfo "History: 1.06"
ModuleInfo "History: Update to SQLite 3.4.2."
ModuleInfo "History: 1.05"
ModuleInfo "History: Fixed database Close to cleanup non-finalized queries."
ModuleInfo "History: 1.04"
ModuleInfo "History: Improved error message details."
ModuleInfo "History: 1.03"
ModuleInfo "History: Fixed NextRow returning True on empty queries."
ModuleInfo "History: 1.02"
ModuleInfo "History: Fixed issue with mis-count of bound parameters."
ModuleInfo "History: 1.01"
ModuleInfo "History: Added hasPrepareSupport() and hasTransactionSupport() methods."
ModuleInfo "History: 1.00 Initial Release"
ModuleInfo "History: Includes SQLite 3.3.13 source."
ModuleInfo "CC_OPTS: -DSQLITE_USER_AUTHENTICATION"
ModuleInfo "CC_OPTS: -DSQLITE_DQS=0"
import brl.blitz
import database.core
SQLITE_OK%=0
SQLITE_ERROR%=1
SQLITE_INTERNAL%=2
SQLITE_PERM%=3
SQLITE_ABORT%=4
SQLITE_BUSY%=5
SQLITE_LOCKED%=6
SQLITE_NOMEM%=7
SQLITE_READONLY%=8
SQLITE_INTERRUPT%=9
SQLITE_IOERR%=10
SQLITE_CORRUPT%=11
SQLITE_NOTFOUND%=12
SQLITE_FULL%=13
SQLITE_CANTOPEN%=14
SQLITE_PROTOCOL%=15
SQLITE_EMPTY%=16
SQLITE_SCHEMA%=17
SQLITE_TOOBIG%=18
SQLITE_CONSTRAINT%=19
SQLITE_MISMATCH%=20
SQLITE_MISUSE%=21
SQLITE_NOLFS%=22
SQLITE_AUTH%=23
SQLITE_FORMAT%=24
SQLITE_RANGE%=25
SQLITE_NOTADB%=26
SQLITE_NOTICE%=27
SQLITE_WARNING%=28
SQLITE_ROW%=100
SQLITE_DONE%=101
SQLITE_INTEGER%=1
SQLITE_FLOAT%=2
SQLITE_TEXT%=3
SQLITE_BLOB%=4
SQLITE_NULL%=5
SQLITE_OPEN_READONLY%=1
SQLITE_OPEN_READWRITE%=2
SQLITE_OPEN_CREATE%=4
SQLITE_OPEN_DELETEONCLOSE%=8
SQLITE_OPEN_EXCLUSIVE%=16
SQLITE_OPEN_AUTOPROXY%=32
SQLITE_OPEN_URI%=64
SQLITE_OPEN_MEMORY%=128
SQLITE_OPEN_MAIN_DB%=256
SQLITE_OPEN_TEMP_DB%=512
SQLITE_OPEN_TRANSIENT_DB%=1024
SQLITE_OPEN_MAIN_JOURNAL%=2048
SQLITE_OPEN_TEMP_JOURNAL%=4096
SQLITE_OPEN_SUBJOURNAL%=8192
SQLITE_OPEN_MASTER_JOURNAL%=16384
SQLITE_OPEN_NOMUTEX%=32768
SQLITE_OPEN_FULLMUTEX%=65536
SQLITE_OPEN_SHAREDCACHE%=131072
SQLITE_OPEN_PRIVATECACHE%=262144
SQLITE_OPEN_WAL%=524288
SQLITE_OPEN_NOFOLLOW%=16777216
SQLITE_OPEN_EXRESCODE%=33554432
sqlite3_close%(handle@*)="sqlite3_close"
sqlite3_open_v2%(dhname@*,handle@*,flags%,fvs@*)="sqlite3_open_v2"
sqlite3_prepare_v2%(dbhandle@*,sql@*,size%,stmtHandle@**,pzTail%)="sqlite3_prepare_v2"
sqlite3_finalize(stmtHandle@*)="sqlite3_finalize"
sqlite3_reset%(stmtHandle@*)="sqlite3_reset"
sqlite3_step%(stmtHandle@*)="sqlite3_step"
sqlite3_column_count%(stmtHandle@*)="sqlite3_column_count"
sqlite3_column_name@*(stmtHandle@*,index%)="sqlite3_column_name"
sqlite3_column_decltype@*(stmtHandle@*,index%)="sqlite3_column_decltype"
sqlite3_column_type%(stmtHandle@*,index%)="sqlite3_column_type"
sqlite3_column_int%(stmtHandle@*,index%)="sqlite3_column_int"
sqlite3_column_int64%%(stmtHandle@*,index%)="sqlite3_column_int64"
sqlite3_column_double!(stmtHandle@*,index%)="sqlite3_column_double"
sqlite3_column_blob@*(stmtHandle@*,index%)="sqlite3_column_blob"
sqlite3_column_bytes%(stmtHandle@*,index%)="sqlite3_column_bytes"
sqlite3_column_text@*(stmtHandle@*,index%)="sqlite3_column_text"
sqlite3_bind_parameter_count%(stmtHandle@*)="sqlite3_bind_parameter_count"
sqlite3_bind_null%(stmtHandle@*,index%)="sqlite3_bind_null"
sqlite3_bind_int%(stmtHandle@*,index%,value%)="sqlite3_bind_int"
sqlite3_bind_int64%(stmtHandle@*,index%,value%%)="sqlite3_bind_int64"
sqlite3_bind_double%(stmtHandle@*,index%,value!)="sqlite3_bind_double"
sqlite3_changes%(handle@*)="sqlite3_changes"
sqlite3_errmsg@*(handle@*)="sqlite3_errmsg"
sqlite3_backup_init@*(toHandle@*,dbTo@*,fromHandle@*,dbFrom@*)="sqlite3_backup_init"
sqlite3_backup_step%(handle@*,page%)="sqlite3_backup_step"
sqlite3_backup_finish%(handle@*)="sqlite3_backup_finish"
sqlite3_errcode%(handle@*)="sqlite3_errcode"
bmx_sqlite3_bind_text64%(stmtHandle@*,index%,value@*,size%%,how%)="bmx_sqlite3_bind_text64"
bmx_sqlite3_bind_blob64%(stmtHandle@*,index%,value@*,size%%,how%)="bmx_sqlite3_bind_blob64"
bmx_sqlite3_column_int64(stmtHandle@*,index%,value%%*)="bmx_sqlite3_column_int64"
bmx_sqlite3_last_insert_rowid(handle@*,id%%*)="bmx_sqlite3_last_insert_rowid"
sqlite3_user_authenticate%(dbhandle@*,username@*,password@*,passlen%)="sqlite3_user_authenticate"
sqlite3_user_add%(dbhandle@*,username@*,password@*,passlen%,isAdmin%)="sqlite3_user_add"
sqlite3_user_change%(dbhandle@*,username@*,password@*,passlen%,isAdmin%)="sqlite3_user_change"
sqlite3_user_delete%(dbhandle@*,username@*)="sqlite3_user_delete"
TSQLiteDatabaseLoader^TDatabaseLoader{
-New()="database_sqlite_TSQLiteDatabaseLoader_New"
-LoadDatabase:TDBConnection(dbname$=$"",host$=$"",port%=0,user$=$"",password$=$"",server$=$"",options$=$"")="database_sqlite_TSQLiteDatabaseLoader_LoadDatabase_SSiSSSS"
}="database_sqlite_TSQLiteDatabaseLoader"
TDBSQLite^TDBConnection{
.queries:TSQLiteResultSet&[]&
-Delete()="_database_sqlite_TDBSQLite_Delete"
+Create:TDBConnection(dbname$=$"",host$=$"",port%=0,user$=$"",password$=$"",server$=$"",options$=$"")="database_sqlite_TDBSQLite_Create_TTDBConnection_SSiSSSS"
-close()="database_sqlite_TDBSQLite_close"
-commit%()="database_sqlite_TDBSQLite_commit"
-getTables$&[]()="database_sqlite_TDBSQLite_getTables"
-getTableInfo:TDBTable(tableName$,withDDL%=0)="database_sqlite_TDBSQLite_getTableInfo_Si"
-open%(user$=$"",pass$=$"")="database_sqlite_TDBSQLite_open_SS"
-rollback%()="database_sqlite_TDBSQLite_rollback"
-startTransaction%()="database_sqlite_TDBSQLite_startTransaction"
-databaseHandle@*()="database_sqlite_TDBSQLite_databaseHandle"
-createResultSet:TQueryResultSet()="database_sqlite_TDBSQLite_createResultSet"
-nativeErrorMessage$(err%)="database_sqlite_TDBSQLite_nativeErrorMessage_i"
-hasPrepareSupport%()="database_sqlite_TDBSQLite_hasPrepareSupport"
-hasTransactionSupport%()="database_sqlite_TDBSQLite_hasTransactionSupport"
-clearQueries()="database_sqlite_TDBSQLite_clearQueries"
-resetQueries()="database_sqlite_TDBSQLite_resetQueries"
-addQuery(query:TSQLiteResultSet)="database_sqlite_TDBSQLite_addQuery_TTSQLiteResultSet"
-removeQuery(query:TSQLiteResultSet)="database_sqlite_TDBSQLite_removeQuery_TTSQLiteResultSet"
-addUser(username$,password$,isAdmin%=0)="database_sqlite_TDBSQLite_addUser_SSi"
-modifyUser(username$,password$,isAdmin%=0)="database_sqlite_TDBSQLite_modifyUser_SSi"
-deleteUser(username$)="database_sqlite_TDBSQLite_deleteUser_S"
}="database_sqlite_TDBSQLite"
TSQLiteResultSet^TQueryResultSet{
.initialFetch%&
.fakeFirstRowFetch%&
-Delete()="_database_sqlite_TSQLiteResultSet_Delete"
-free()="database_sqlite_TSQLiteResultSet_free"
-reset()="database_sqlite_TSQLiteResultSet_reset"
+Create:TQueryResultSet(db:TDBConnection,sql$=$"")="database_sqlite_TSQLiteResultSet_Create_TTQueryResultSet_TTDBConnectionS"
-executeQuery%(statement$)="database_sqlite_TSQLiteResultSet_executeQuery_S"
-cleanup()="database_sqlite_TSQLiteResultSet_cleanup"
-prepare%(stmt$)="database_sqlite_TSQLiteResultSet_prepare_S"
-execute%()="database_sqlite_TSQLiteResultSet_execute"
-firstRow%()="database_sqlite_TSQLiteResultSet_firstRow"
-nextRow%()="database_sqlite_TSQLiteResultSet_nextRow"
-initRecord()="database_sqlite_TSQLiteResultSet_initRecord"
+dbTypeFromNative%(name$,_type%=0,_flags%=0)="database_sqlite_TSQLiteResultSet_dbTypeFromNative_i_Sii"
-lastInsertedId%%()="database_sqlite_TSQLiteResultSet_lastInsertedId"
-rowsAffected%()="database_sqlite_TSQLiteResultSet_rowsAffected"
}="database_sqlite_TSQLiteResultSet"
loadOrSaveDB%(inMemory:TDBSQLite,filename$,isSave%,database$=$"main")="database_sqlite_loadOrSaveDB"